package RPM::Source::Transformation::Factory::BundleImport::SetupPkgMacros;

use strict;
use warnings;
use Carp;

use RPM::Source::BundleImport::RedefineMacro qw/redefine_macro/;
use RPM::Source::Transformation::Factory::BundleImport::RegisterPkgMacros;
use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Factory/;
push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

our $verbose=0;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	-priority => PRIORITY_BUNDLE_SETUP,
	-name => 'tarball_update_set_macros_pkg',
	-opt_handler_sub=>\&opt_handler_update_macros),
	;
}

sub opt_handler_update_macros {
    my (undef,$spec,undef,$converter_opt,$resourceobj)=@_;
    my $mainsec=$spec->main_section;
    my $macros_pkg_name = $converter_opt->{-macros_pkg_name};
    if ($macros_pkg_name and $macros_pkg_name ne 'name') {
	&redefine_macro($mainsec,$macros_pkg_name,$converter_opt->{-opt_bundle_name});
    }
    my $macros_pkg_version = $converter_opt->{-macros_pkg_version};
    if ($macros_pkg_version and $macros_pkg_version ne 'version') {
	&redefine_macro($mainsec,$macros_pkg_version,$converter_opt->{-opt_bundle_version});
    }
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
