package RPM::Source::Transformation::InputHandler::UpdateList5;

use strict;
use warnings;

use RPM::Source::Transform;
use RPM::Source::Transformation::Component::InputNameCommon;
# provides url downloads for UpdateList5
use RPM::Source::Transformation::Factory::BundleImport::DownloadInput;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;
$RPM::Source::TransformContainer::INPUT_HANDLER=__PACKAGE__;

our $download_url=sub { return $_[0] };
our $sourcetag_url=sub { return $_[0] };

our $VERSION=0.001;
our $verbose=0;

#my $opt_input_list_type=5;
#our @LONGOPT=(
#	"input4"   => \$opt_input4,
#    );
# sub print_longopt {
#     print "  Input options:
#     --input3 3 column list (rpmname version url)
#     --input5 5 column list (rpmname pkgname oldver newver url)
# ";
# }

sub process_args {}

sub verify_args {
    my ($class)=@_;
    if (not grep {-e $_} @ARGV) {
	print STDERR "command line arguments not found: ", join(' ',@ARGV),"\n";
	$class->usage();
	exit 0;
    }
    return 1;
}

package RPM::Source::Transform;

use strict;
use warnings;

sub transform {
    my ($class)=@_;
    foreach my $update (<>) {
	&transform_update5($class,$update);
    }
}

sub transform_update5 {
    my (undef, $update)=@_;
    my ($rpmname,$module,$oldver,$newver,$url)=split(/\s+/,$update,-1);
    my $converter_opt=RPM::Source::TransformContainer->mk_opt();
    $converter_opt->{-input_handler_arg_input_name}=$rpmname;
    $converter_opt->{-version}=$newver;
    $converter_opt->{-opt_bundle_name}=$module;
    $converter_opt->{-opt_bundle_version}=$newver;
    $converter_opt->{-opt_bundle_url}=&$sourcetag_url($url);
    $converter_opt->{-opt_bundle_download_url}=&$download_url($url);

    if ($verbose) {
	print STDERR "\n--------------------------------------------------------\n";
	print STDERR "update5: $rpmname ($module): $oldver -> $newver $url\n";
    }

    my $resourceobj=RPM::Source::TransformContainer->mk_resourceobj();
    my $spec=$RPM::Source::TransformContainer::Name2SpecProvider->name2spec($rpmname,$converter_opt,$resourceobj);
    RPM::Source::TransformContainer->transform_once($spec,undef,$converter_opt);
    print STDERR "---*---\n" if $verbose;
}

1;
