#!/usr/bin/perl

use strict;
use warnings;

use Carp;
use Getopt::Long;
#use File::Basename;
use YAML::Any qw//; # Dump Load DumpFile LoadFile

use RPM::Source::BundleImport::Perl::Eval;
use RPM::Source::BundleImport::Perl::CPAN2RPM_get_meta;
$RPM::Source::BundleImport::Perl::CPAN2RPM_get_meta::opt_eval_keep_pipes=0;

my $verbose=0;
my ($debug,$unpack_path,$fileprefix);
GetOptions (
    'dir=s' => \$unpack_path,
    'dump=s' => \$fileprefix,
    'debug' => \$debug,
    'verbose' => \$verbose,
    );

$RPM::Source::BundleImport::Perl::CPAN2RPM_get_meta::opt_eval_keep_pipes=1 if $verbose;

my $_meta=&RPM::Source::BundleImport::Perl::CPAN2RPM_get_meta::cpan2rpm_get_meta($unpack_path);
my $hooks_collected=$RPM::Source::BundleImport::Perl::Eval::collected_data;

if ($debug) {
    print YAML::Any::Dump($_meta);
    print YAML::Any::Dump($hooks_collected);
}

if ($fileprefix) {
    print YAML::Any::DumpFile($fileprefix.'-meta.yml',$_meta);
    print YAML::Any::DumpFile($fileprefix.'-hooks.yml',$hooks_collected);
}
